////////////////////////////////////////////////////////////////////////////////
// The following FIT Protocol software provided may be used with FIT protocol
// devices only and remains the copyrighted property of Garmin Canada Inc.
// The software is being provided on an "as-is" basis and as an accommodation,
// and therefore all warranties, representations, or guarantees of any kind
// (whether express, implied or statutory) including, without limitation,
// warranties of merchantability, non-infringement, or fitness for a particular
// purpose, are specifically disclaimed.
//
// Copyright 2020 Garmin Canada Inc.
////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.32Release
// Tag = production/akw/21.32.00-0-g756ff70
////////////////////////////////////////////////////////////////////////////////


package com.garmin.fit;
import java.math.BigInteger;


public class CapabilitiesMesg extends Mesg {

    
    public static final int LanguagesFieldNum = 0;
    
    public static final int SportsFieldNum = 1;
    
    public static final int WorkoutsSupportedFieldNum = 21;
    
    public static final int ConnectivitySupportedFieldNum = 23;
    

    protected static final  Mesg capabilitiesMesg;
    static {
        // capabilities
        capabilitiesMesg = new Mesg("capabilities", MesgNum.CAPABILITIES);
        capabilitiesMesg.addField(new Field("languages", LanguagesFieldNum, 10, 1, 0, "", false, Profile.Type.UINT8Z));
        
        capabilitiesMesg.addField(new Field("sports", SportsFieldNum, 10, 1, 0, "", false, Profile.Type.SPORT_BITS_0));
        
        capabilitiesMesg.addField(new Field("workouts_supported", WorkoutsSupportedFieldNum, 140, 1, 0, "", false, Profile.Type.WORKOUT_CAPABILITIES));
        
        capabilitiesMesg.addField(new Field("connectivity_supported", ConnectivitySupportedFieldNum, 140, 1, 0, "", false, Profile.Type.CONNECTIVITY_CAPABILITIES));
        
    }

    public CapabilitiesMesg() {
        super(Factory.createMesg(MesgNum.CAPABILITIES));
    }

    public CapabilitiesMesg(final Mesg mesg) {
        super(mesg);
    }


    public Short[] getLanguages() {
        
        return getFieldShortValues(0, Fit.SUBFIELD_INDEX_MAIN_FIELD);
        
    }

    /**
     * @return number of languages
     */
    public int getNumLanguages() {
        return getNumFieldValues(0, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get languages field
     * Comment: Use language_bits_x types where x is index of array.
     *
     * @param index of languages
     * @return languages
     */
    public Short getLanguages(int index) {
        return getFieldShortValue(0, index, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set languages field
     * Comment: Use language_bits_x types where x is index of array.
     *
     * @param index of languages
     * @param languages
     */
    public void setLanguages(int index, Short languages) {
        setFieldValue(0, index, languages, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    public Short[] getSports() {
        
        return getFieldShortValues(1, Fit.SUBFIELD_INDEX_MAIN_FIELD);
        
    }

    /**
     * @return number of sports
     */
    public int getNumSports() {
        return getNumFieldValues(1, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get sports field
     * Comment: Use sport_bits_x types where x is index of array.
     *
     * @param index of sports
     * @return sports
     */
    public Short getSports(int index) {
        return getFieldShortValue(1, index, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set sports field
     * Comment: Use sport_bits_x types where x is index of array.
     *
     * @param index of sports
     * @param sports
     */
    public void setSports(int index, Short sports) {
        setFieldValue(1, index, sports, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get workouts_supported field
     *
     * @return workouts_supported
     */
    public Long getWorkoutsSupported() {
        return getFieldLongValue(21, 0, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set workouts_supported field
     *
     * @param workoutsSupported
     */
    public void setWorkoutsSupported(Long workoutsSupported) {
        setFieldValue(21, 0, workoutsSupported, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get connectivity_supported field
     *
     * @return connectivity_supported
     */
    public Long getConnectivitySupported() {
        return getFieldLongValue(23, 0, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set connectivity_supported field
     *
     * @param connectivitySupported
     */
    public void setConnectivitySupported(Long connectivitySupported) {
        setFieldValue(23, 0, connectivitySupported, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

}
