////////////////////////////////////////////////////////////////////////////////
// The following FIT Protocol software provided may be used with FIT protocol
// devices only and remains the copyrighted property of Garmin Canada Inc.
// The software is being provided on an "as-is" basis and as an accommodation,
// and therefore all warranties, representations, or guarantees of any kind
// (whether express, implied or statutory) including, without limitation,
// warranties of merchantability, non-infringement, or fitness for a particular
// purpose, are specifically disclaimed.
//
// Copyright 2020 Garmin Canada Inc.
////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.32Release
// Tag = production/akw/21.32.00-0-g756ff70
////////////////////////////////////////////////////////////////////////////////


package com.garmin.fit;

import java.util.HashMap;
import java.util.Map;

public class CommTimeoutType {
    public static final int WILDCARD_PAIRING_TIMEOUT = 0; // Timeout pairing to any device
    public static final int PAIRING_TIMEOUT = 1; // Timeout pairing to previously paired device
    public static final int CONNECTION_LOST = 2; // Temporary loss of communications
    public static final int CONNECTION_TIMEOUT = 3; // Connection closed due to extended bad communications
    public static final int INVALID = Fit.UINT16_INVALID;

    private static final Map<Integer, String> stringMap;

    static {
        stringMap = new HashMap<Integer, String>();
        stringMap.put(WILDCARD_PAIRING_TIMEOUT, "WILDCARD_PAIRING_TIMEOUT");
        stringMap.put(PAIRING_TIMEOUT, "PAIRING_TIMEOUT");
        stringMap.put(CONNECTION_LOST, "CONNECTION_LOST");
        stringMap.put(CONNECTION_TIMEOUT, "CONNECTION_TIMEOUT");
    }


    /**
     * Retrieves the String Representation of the Value
     * @return The string representation of the value, or empty if unknown
     */
    public static String getStringFromValue( Integer value ) {
        if( stringMap.containsKey( value ) ) {
            return stringMap.get( value );
        }

        return "";
    }

    /**
     * Retrieves a value given a string representation
     * @return The value or INVALID if unkwown
     */
    public static Integer getValueFromString( String value ) {
        for( Map.Entry<Integer, String> entry : stringMap.entrySet() ) {
            if( entry.getValue().equals( value ) ) {
                return entry.getKey();
            }
        }

        return INVALID;
    }

}
