////////////////////////////////////////////////////////////////////////////////
// The following FIT Protocol software provided may be used with FIT protocol
// devices only and remains the copyrighted property of Garmin Canada Inc.
// The software is being provided on an "as-is" basis and as an accommodation,
// and therefore all warranties, representations, or guarantees of any kind
// (whether express, implied or statutory) including, without limitation,
// warranties of merchantability, non-infringement, or fitness for a particular
// purpose, are specifically disclaimed.
//
// Copyright 2020 Garmin Canada Inc.
////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.32Release
// Tag = production/akw/21.32.00-0-g756ff70
////////////////////////////////////////////////////////////////////////////////


package com.garmin.fit;

import java.util.HashMap;
import java.util.Map;

public class GarminProduct {
    public static final int HRM1 = 1;
    public static final int AXH01 = 2; // AXH01 HRM chipset
    public static final int AXB01 = 3;
    public static final int AXB02 = 4;
    public static final int HRM2SS = 5;
    public static final int DSI_ALF02 = 6;
    public static final int HRM3SS = 7;
    public static final int HRM_RUN_SINGLE_BYTE_PRODUCT_ID = 8; // hrm_run model for HRM ANT+ messaging
    public static final int BSM = 9; // BSM model for ANT+ messaging
    public static final int BCM = 10; // BCM model for ANT+ messaging
    public static final int AXS01 = 11; // AXS01 HRM Bike Chipset model for ANT+ messaging
    public static final int HRM_TRI_SINGLE_BYTE_PRODUCT_ID = 12; // hrm_tri model for HRM ANT+ messaging
    public static final int HRM4_RUN_SINGLE_BYTE_PRODUCT_ID = 13; // hrm4 run model for HRM ANT+ messaging
    public static final int FR225_SINGLE_BYTE_PRODUCT_ID = 14; // fr225 model for HRM ANT+ messaging
    public static final int FR301_CHINA = 473;
    public static final int FR301_JAPAN = 474;
    public static final int FR301_KOREA = 475;
    public static final int FR301_TAIWAN = 494;
    public static final int FR405 = 717; // Forerunner 405
    public static final int FR50 = 782; // Forerunner 50
    public static final int FR405_JAPAN = 987;
    public static final int FR60 = 988; // Forerunner 60
    public static final int DSI_ALF01 = 1011;
    public static final int FR310XT = 1018; // Forerunner 310
    public static final int EDGE500 = 1036;
    public static final int FR110 = 1124; // Forerunner 110
    public static final int EDGE800 = 1169;
    public static final int EDGE500_TAIWAN = 1199;
    public static final int EDGE500_JAPAN = 1213;
    public static final int CHIRP = 1253;
    public static final int FR110_JAPAN = 1274;
    public static final int EDGE200 = 1325;
    public static final int FR910XT = 1328;
    public static final int EDGE800_TAIWAN = 1333;
    public static final int EDGE800_JAPAN = 1334;
    public static final int ALF04 = 1341;
    public static final int FR610 = 1345;
    public static final int FR210_JAPAN = 1360;
    public static final int VECTOR_SS = 1380;
    public static final int VECTOR_CP = 1381;
    public static final int EDGE800_CHINA = 1386;
    public static final int EDGE500_CHINA = 1387;
    public static final int APPROACH_G10 = 1405;
    public static final int FR610_JAPAN = 1410;
    public static final int EDGE500_KOREA = 1422;
    public static final int FR70 = 1436;
    public static final int FR310XT_4T = 1446;
    public static final int AMX = 1461;
    public static final int FR10 = 1482;
    public static final int EDGE800_KOREA = 1497;
    public static final int SWIM = 1499;
    public static final int FR910XT_CHINA = 1537;
    public static final int FENIX = 1551;
    public static final int EDGE200_TAIWAN = 1555;
    public static final int EDGE510 = 1561;
    public static final int EDGE810 = 1567;
    public static final int TEMPE = 1570;
    public static final int FR910XT_JAPAN = 1600;
    public static final int FR620 = 1623;
    public static final int FR220 = 1632;
    public static final int FR910XT_KOREA = 1664;
    public static final int FR10_JAPAN = 1688;
    public static final int EDGE810_JAPAN = 1721;
    public static final int VIRB_ELITE = 1735;
    public static final int EDGE_TOURING = 1736; // Also Edge Touring Plus
    public static final int EDGE510_JAPAN = 1742;
    public static final int HRM_TRI = 1743;
    public static final int HRM_RUN = 1752;
    public static final int FR920XT = 1765;
    public static final int EDGE510_ASIA = 1821;
    public static final int EDGE810_CHINA = 1822;
    public static final int EDGE810_TAIWAN = 1823;
    public static final int EDGE1000 = 1836;
    public static final int VIVO_FIT = 1837;
    public static final int VIRB_REMOTE = 1853;
    public static final int VIVO_KI = 1885;
    public static final int FR15 = 1903;
    public static final int VIVO_ACTIVE = 1907;
    public static final int EDGE510_KOREA = 1918;
    public static final int FR620_JAPAN = 1928;
    public static final int FR620_CHINA = 1929;
    public static final int FR220_JAPAN = 1930;
    public static final int FR220_CHINA = 1931;
    public static final int APPROACH_S6 = 1936;
    public static final int VIVO_SMART = 1956;
    public static final int FENIX2 = 1967;
    public static final int EPIX = 1988;
    public static final int FENIX3 = 2050;
    public static final int EDGE1000_TAIWAN = 2052;
    public static final int EDGE1000_JAPAN = 2053;
    public static final int FR15_JAPAN = 2061;
    public static final int EDGE520 = 2067;
    public static final int EDGE1000_CHINA = 2070;
    public static final int FR620_RUSSIA = 2072;
    public static final int FR220_RUSSIA = 2073;
    public static final int VECTOR_S = 2079;
    public static final int EDGE1000_KOREA = 2100;
    public static final int FR920XT_TAIWAN = 2130;
    public static final int FR920XT_CHINA = 2131;
    public static final int FR920XT_JAPAN = 2132;
    public static final int VIRBX = 2134;
    public static final int VIVO_SMART_APAC = 2135;
    public static final int ETREX_TOUCH = 2140;
    public static final int EDGE25 = 2147;
    public static final int FR25 = 2148;
    public static final int VIVO_FIT2 = 2150;
    public static final int FR225 = 2153;
    public static final int FR630 = 2156;
    public static final int FR230 = 2157;
    public static final int FR735XT = 2158;
    public static final int VIVO_ACTIVE_APAC = 2160;
    public static final int VECTOR_2 = 2161;
    public static final int VECTOR_2S = 2162;
    public static final int VIRBXE = 2172;
    public static final int FR620_TAIWAN = 2173;
    public static final int FR220_TAIWAN = 2174;
    public static final int TRUSWING = 2175;
    public static final int FENIX3_CHINA = 2188;
    public static final int FENIX3_TWN = 2189;
    public static final int VARIA_HEADLIGHT = 2192;
    public static final int VARIA_TAILLIGHT_OLD = 2193;
    public static final int EDGE_EXPLORE_1000 = 2204;
    public static final int FR225_ASIA = 2219;
    public static final int VARIA_RADAR_TAILLIGHT = 2225;
    public static final int VARIA_RADAR_DISPLAY = 2226;
    public static final int EDGE20 = 2238;
    public static final int EDGE520_ASIA = 2260;
    public static final int EDGE520_JAPAN = 2261;
    public static final int D2_BRAVO = 2262;
    public static final int APPROACH_S20 = 2266;
    public static final int VIVO_SMART2 = 2271;
    public static final int EDGE1000_THAI = 2274;
    public static final int VARIA_REMOTE = 2276;
    public static final int EDGE25_ASIA = 2288;
    public static final int EDGE25_JPN = 2289;
    public static final int EDGE20_ASIA = 2290;
    public static final int APPROACH_X40 = 2292;
    public static final int FENIX3_JAPAN = 2293;
    public static final int VIVO_SMART_EMEA = 2294;
    public static final int FR630_ASIA = 2310;
    public static final int FR630_JPN = 2311;
    public static final int FR230_JPN = 2313;
    public static final int HRM4_RUN = 2327;
    public static final int EPIX_JAPAN = 2332;
    public static final int VIVO_ACTIVE_HR = 2337;
    public static final int VIVO_SMART_GPS_HR = 2347;
    public static final int VIVO_SMART_HR = 2348;
    public static final int VIVO_SMART_HR_ASIA = 2361;
    public static final int VIVO_SMART_GPS_HR_ASIA = 2362;
    public static final int VIVO_MOVE = 2368;
    public static final int VARIA_TAILLIGHT = 2379;
    public static final int FR235_JAPAN = 2397;
    public static final int VARIA_VISION = 2398;
    public static final int VIVO_FIT3 = 2406;
    public static final int FENIX3_KOREA = 2407;
    public static final int FENIX3_SEA = 2408;
    public static final int FENIX3_HR = 2413;
    public static final int VIRB_ULTRA_30 = 2417;
    public static final int INDEX_SMART_SCALE = 2429;
    public static final int FR235 = 2431;
    public static final int FENIX3_CHRONOS = 2432;
    public static final int OREGON7XX = 2441;
    public static final int RINO7XX = 2444;
    public static final int EPIX_KOREA = 2457;
    public static final int FENIX3_HR_CHN = 2473;
    public static final int FENIX3_HR_TWN = 2474;
    public static final int FENIX3_HR_JPN = 2475;
    public static final int FENIX3_HR_SEA = 2476;
    public static final int FENIX3_HR_KOR = 2477;
    public static final int NAUTIX = 2496;
    public static final int VIVO_ACTIVE_HR_APAC = 2497;
    public static final int OREGON7XX_WW = 2512;
    public static final int EDGE_820 = 2530;
    public static final int EDGE_EXPLORE_820 = 2531;
    public static final int FR735XT_APAC = 2533;
    public static final int FR735XT_JAPAN = 2534;
    public static final int FENIX5S = 2544;
    public static final int D2_BRAVO_TITANIUM = 2547;
    public static final int VARIA_UT800 = 2567; // Varia UT 800 SW
    public static final int RUNNING_DYNAMICS_POD = 2593;
    public static final int EDGE_820_CHINA = 2599;
    public static final int EDGE_820_JAPAN = 2600;
    public static final int FENIX5X = 2604;
    public static final int VIVO_FIT_JR = 2606;
    public static final int VIVO_SMART3 = 2622;
    public static final int VIVO_SPORT = 2623;
    public static final int EDGE_820_TAIWAN = 2628;
    public static final int EDGE_820_KOREA = 2629;
    public static final int EDGE_820_SEA = 2630;
    public static final int FR35_HEBREW = 2650;
    public static final int APPROACH_S60 = 2656;
    public static final int FR35_APAC = 2667;
    public static final int FR35_JAPAN = 2668;
    public static final int FENIX3_CHRONOS_ASIA = 2675;
    public static final int VIRB_360 = 2687;
    public static final int FR935 = 2691;
    public static final int FENIX5 = 2697;
    public static final int VIVOACTIVE3 = 2700;
    public static final int FR235_CHINA_NFC = 2733;
    public static final int FORETREX_601_701 = 2769;
    public static final int VIVO_MOVE_HR = 2772;
    public static final int EDGE_1030 = 2713;
    public static final int FENIX5_ASIA = 2796;
    public static final int FENIX5S_ASIA = 2797;
    public static final int FENIX5X_ASIA = 2798;
    public static final int APPROACH_Z80 = 2806;
    public static final int FR35_KOREA = 2814;
    public static final int D2CHARLIE = 2819;
    public static final int VIVO_SMART3_APAC = 2831;
    public static final int VIVO_SPORT_APAC = 2832;
    public static final int FR935_ASIA = 2833;
    public static final int DESCENT = 2859;
    public static final int FR645 = 2886;
    public static final int FR645M = 2888;
    public static final int FR30 = 2891;
    public static final int FENIX5S_PLUS = 2900;
    public static final int EDGE_130 = 2909;
    public static final int EDGE_1030_ASIA = 2924;
    public static final int VIVOSMART_4 = 2927;
    public static final int VIVO_MOVE_HR_ASIA = 2945;
    public static final int APPROACH_X10 = 2962;
    public static final int FR30_ASIA = 2977;
    public static final int VIVOACTIVE3M_W = 2988;
    public static final int FR645_ASIA = 3003;
    public static final int FR645M_ASIA = 3004;
    public static final int EDGE_EXPLORE = 3011;
    public static final int GPSMAP66 = 3028;
    public static final int APPROACH_S10 = 3049;
    public static final int VIVOACTIVE3M_L = 3066;
    public static final int APPROACH_G80 = 3085;
    public static final int EDGE_130_ASIA = 3092;
    public static final int EDGE_1030_BONTRAGER = 3095;
    public static final int FENIX5_PLUS = 3110;
    public static final int FENIX5X_PLUS = 3111;
    public static final int EDGE_520_PLUS = 3112;
    public static final int EDGE_530 = 3121;
    public static final int EDGE_830 = 3122;
    public static final int FENIX5S_PLUS_APAC = 3134;
    public static final int FENIX5X_PLUS_APAC = 3135;
    public static final int EDGE_520_PLUS_APAC = 3142;
    public static final int FR235L_ASIA = 3144;
    public static final int FR245_ASIA = 3145;
    public static final int VIVO_ACTIVE3M_APAC = 3163;
    public static final int VIVO_SMART4_ASIA = 3218;
    public static final int VIVOACTIVE4_SMALL = 3224;
    public static final int VIVOACTIVE4_LARGE = 3225;
    public static final int VENU = 3226;
    public static final int MARQ_DRIVER = 3246;
    public static final int MARQ_AVIATOR = 3247;
    public static final int MARQ_CAPTAIN = 3248;
    public static final int MARQ_COMMANDER = 3249;
    public static final int MARQ_EXPEDITION = 3250;
    public static final int MARQ_ATHLETE = 3251;
    public static final int FENIX6S_SPORT = 3287;
    public static final int FENIX6S = 3288;
    public static final int FENIX6_SPORT = 3289;
    public static final int FENIX6 = 3290;
    public static final int FENIX6X = 3291;
    public static final int HRM_DUAL = 3299; // HRM-Dual
    public static final int VIVO_MOVE3_PREMIUM = 3308;
    public static final int APPROACH_S40 = 3314;
    public static final int FR245M_ASIA = 3321;
    public static final int EDGE_530_APAC = 3349;
    public static final int EDGE_830_APAC = 3350;
    public static final int VIVO_MOVE3 = 3378;
    public static final int VIVO_ACTIVE4_SMALL_ASIA = 3387;
    public static final int VIVO_ACTIVE4_LARGE_ASIA = 3388;
    public static final int VIVO_ACTIVE4_OLED_ASIA = 3389;
    public static final int SWIM2 = 3405;
    public static final int MARQ_DRIVER_ASIA = 3420;
    public static final int MARQ_AVIATOR_ASIA = 3421;
    public static final int VIVO_MOVE3_ASIA = 3422;
    public static final int VIVO_ACTIVE3T_CHN = 3446;
    public static final int MARQ_CAPTAIN_ASIA = 3448;
    public static final int MARQ_COMMANDER_ASIA = 3449;
    public static final int MARQ_EXPEDITION_ASIA = 3450;
    public static final int MARQ_ATHLETE_ASIA = 3451;
    public static final int FR45_ASIA = 3469;
    public static final int VIVOACTIVE3_DAIMLER = 3473;
    public static final int FENIX6S_SPORT_ASIA = 3512;
    public static final int FENIX6S_ASIA = 3513;
    public static final int FENIX6_SPORT_ASIA = 3514;
    public static final int FENIX6_ASIA = 3515;
    public static final int FENIX6X_ASIA = 3516;
    public static final int MARQ_ADVENTURER = 3624;
    public static final int MARQ_ADVENTURER_ASIA = 3648;
    public static final int SWIM2_APAC = 3639;
    public static final int VENU_DAIMLER_ASIA = 3737;
    public static final int VENU_DAIMLER = 3740;
    public static final int SDM4 = 10007; // SDM4 footpod
    public static final int EDGE_REMOTE = 10014;
    public static final int TRAINING_CENTER = 20119;
    public static final int CONNECTIQ_SIMULATOR = 65531;
    public static final int ANDROID_ANTPLUS_PLUGIN = 65532;
    public static final int CONNECT = 65534; // Garmin Connect website
    public static final int INVALID = Fit.UINT16_INVALID;

    private static final Map<Integer, String> stringMap;

    static {
        stringMap = new HashMap<Integer, String>();
        stringMap.put(HRM1, "HRM1");
        stringMap.put(AXH01, "AXH01");
        stringMap.put(AXB01, "AXB01");
        stringMap.put(AXB02, "AXB02");
        stringMap.put(HRM2SS, "HRM2SS");
        stringMap.put(DSI_ALF02, "DSI_ALF02");
        stringMap.put(HRM3SS, "HRM3SS");
        stringMap.put(HRM_RUN_SINGLE_BYTE_PRODUCT_ID, "HRM_RUN_SINGLE_BYTE_PRODUCT_ID");
        stringMap.put(BSM, "BSM");
        stringMap.put(BCM, "BCM");
        stringMap.put(AXS01, "AXS01");
        stringMap.put(HRM_TRI_SINGLE_BYTE_PRODUCT_ID, "HRM_TRI_SINGLE_BYTE_PRODUCT_ID");
        stringMap.put(HRM4_RUN_SINGLE_BYTE_PRODUCT_ID, "HRM4_RUN_SINGLE_BYTE_PRODUCT_ID");
        stringMap.put(FR225_SINGLE_BYTE_PRODUCT_ID, "FR225_SINGLE_BYTE_PRODUCT_ID");
        stringMap.put(FR301_CHINA, "FR301_CHINA");
        stringMap.put(FR301_JAPAN, "FR301_JAPAN");
        stringMap.put(FR301_KOREA, "FR301_KOREA");
        stringMap.put(FR301_TAIWAN, "FR301_TAIWAN");
        stringMap.put(FR405, "FR405");
        stringMap.put(FR50, "FR50");
        stringMap.put(FR405_JAPAN, "FR405_JAPAN");
        stringMap.put(FR60, "FR60");
        stringMap.put(DSI_ALF01, "DSI_ALF01");
        stringMap.put(FR310XT, "FR310XT");
        stringMap.put(EDGE500, "EDGE500");
        stringMap.put(FR110, "FR110");
        stringMap.put(EDGE800, "EDGE800");
        stringMap.put(EDGE500_TAIWAN, "EDGE500_TAIWAN");
        stringMap.put(EDGE500_JAPAN, "EDGE500_JAPAN");
        stringMap.put(CHIRP, "CHIRP");
        stringMap.put(FR110_JAPAN, "FR110_JAPAN");
        stringMap.put(EDGE200, "EDGE200");
        stringMap.put(FR910XT, "FR910XT");
        stringMap.put(EDGE800_TAIWAN, "EDGE800_TAIWAN");
        stringMap.put(EDGE800_JAPAN, "EDGE800_JAPAN");
        stringMap.put(ALF04, "ALF04");
        stringMap.put(FR610, "FR610");
        stringMap.put(FR210_JAPAN, "FR210_JAPAN");
        stringMap.put(VECTOR_SS, "VECTOR_SS");
        stringMap.put(VECTOR_CP, "VECTOR_CP");
        stringMap.put(EDGE800_CHINA, "EDGE800_CHINA");
        stringMap.put(EDGE500_CHINA, "EDGE500_CHINA");
        stringMap.put(APPROACH_G10, "APPROACH_G10");
        stringMap.put(FR610_JAPAN, "FR610_JAPAN");
        stringMap.put(EDGE500_KOREA, "EDGE500_KOREA");
        stringMap.put(FR70, "FR70");
        stringMap.put(FR310XT_4T, "FR310XT_4T");
        stringMap.put(AMX, "AMX");
        stringMap.put(FR10, "FR10");
        stringMap.put(EDGE800_KOREA, "EDGE800_KOREA");
        stringMap.put(SWIM, "SWIM");
        stringMap.put(FR910XT_CHINA, "FR910XT_CHINA");
        stringMap.put(FENIX, "FENIX");
        stringMap.put(EDGE200_TAIWAN, "EDGE200_TAIWAN");
        stringMap.put(EDGE510, "EDGE510");
        stringMap.put(EDGE810, "EDGE810");
        stringMap.put(TEMPE, "TEMPE");
        stringMap.put(FR910XT_JAPAN, "FR910XT_JAPAN");
        stringMap.put(FR620, "FR620");
        stringMap.put(FR220, "FR220");
        stringMap.put(FR910XT_KOREA, "FR910XT_KOREA");
        stringMap.put(FR10_JAPAN, "FR10_JAPAN");
        stringMap.put(EDGE810_JAPAN, "EDGE810_JAPAN");
        stringMap.put(VIRB_ELITE, "VIRB_ELITE");
        stringMap.put(EDGE_TOURING, "EDGE_TOURING");
        stringMap.put(EDGE510_JAPAN, "EDGE510_JAPAN");
        stringMap.put(HRM_TRI, "HRM_TRI");
        stringMap.put(HRM_RUN, "HRM_RUN");
        stringMap.put(FR920XT, "FR920XT");
        stringMap.put(EDGE510_ASIA, "EDGE510_ASIA");
        stringMap.put(EDGE810_CHINA, "EDGE810_CHINA");
        stringMap.put(EDGE810_TAIWAN, "EDGE810_TAIWAN");
        stringMap.put(EDGE1000, "EDGE1000");
        stringMap.put(VIVO_FIT, "VIVO_FIT");
        stringMap.put(VIRB_REMOTE, "VIRB_REMOTE");
        stringMap.put(VIVO_KI, "VIVO_KI");
        stringMap.put(FR15, "FR15");
        stringMap.put(VIVO_ACTIVE, "VIVO_ACTIVE");
        stringMap.put(EDGE510_KOREA, "EDGE510_KOREA");
        stringMap.put(FR620_JAPAN, "FR620_JAPAN");
        stringMap.put(FR620_CHINA, "FR620_CHINA");
        stringMap.put(FR220_JAPAN, "FR220_JAPAN");
        stringMap.put(FR220_CHINA, "FR220_CHINA");
        stringMap.put(APPROACH_S6, "APPROACH_S6");
        stringMap.put(VIVO_SMART, "VIVO_SMART");
        stringMap.put(FENIX2, "FENIX2");
        stringMap.put(EPIX, "EPIX");
        stringMap.put(FENIX3, "FENIX3");
        stringMap.put(EDGE1000_TAIWAN, "EDGE1000_TAIWAN");
        stringMap.put(EDGE1000_JAPAN, "EDGE1000_JAPAN");
        stringMap.put(FR15_JAPAN, "FR15_JAPAN");
        stringMap.put(EDGE520, "EDGE520");
        stringMap.put(EDGE1000_CHINA, "EDGE1000_CHINA");
        stringMap.put(FR620_RUSSIA, "FR620_RUSSIA");
        stringMap.put(FR220_RUSSIA, "FR220_RUSSIA");
        stringMap.put(VECTOR_S, "VECTOR_S");
        stringMap.put(EDGE1000_KOREA, "EDGE1000_KOREA");
        stringMap.put(FR920XT_TAIWAN, "FR920XT_TAIWAN");
        stringMap.put(FR920XT_CHINA, "FR920XT_CHINA");
        stringMap.put(FR920XT_JAPAN, "FR920XT_JAPAN");
        stringMap.put(VIRBX, "VIRBX");
        stringMap.put(VIVO_SMART_APAC, "VIVO_SMART_APAC");
        stringMap.put(ETREX_TOUCH, "ETREX_TOUCH");
        stringMap.put(EDGE25, "EDGE25");
        stringMap.put(FR25, "FR25");
        stringMap.put(VIVO_FIT2, "VIVO_FIT2");
        stringMap.put(FR225, "FR225");
        stringMap.put(FR630, "FR630");
        stringMap.put(FR230, "FR230");
        stringMap.put(FR735XT, "FR735XT");
        stringMap.put(VIVO_ACTIVE_APAC, "VIVO_ACTIVE_APAC");
        stringMap.put(VECTOR_2, "VECTOR_2");
        stringMap.put(VECTOR_2S, "VECTOR_2S");
        stringMap.put(VIRBXE, "VIRBXE");
        stringMap.put(FR620_TAIWAN, "FR620_TAIWAN");
        stringMap.put(FR220_TAIWAN, "FR220_TAIWAN");
        stringMap.put(TRUSWING, "TRUSWING");
        stringMap.put(FENIX3_CHINA, "FENIX3_CHINA");
        stringMap.put(FENIX3_TWN, "FENIX3_TWN");
        stringMap.put(VARIA_HEADLIGHT, "VARIA_HEADLIGHT");
        stringMap.put(VARIA_TAILLIGHT_OLD, "VARIA_TAILLIGHT_OLD");
        stringMap.put(EDGE_EXPLORE_1000, "EDGE_EXPLORE_1000");
        stringMap.put(FR225_ASIA, "FR225_ASIA");
        stringMap.put(VARIA_RADAR_TAILLIGHT, "VARIA_RADAR_TAILLIGHT");
        stringMap.put(VARIA_RADAR_DISPLAY, "VARIA_RADAR_DISPLAY");
        stringMap.put(EDGE20, "EDGE20");
        stringMap.put(EDGE520_ASIA, "EDGE520_ASIA");
        stringMap.put(EDGE520_JAPAN, "EDGE520_JAPAN");
        stringMap.put(D2_BRAVO, "D2_BRAVO");
        stringMap.put(APPROACH_S20, "APPROACH_S20");
        stringMap.put(VIVO_SMART2, "VIVO_SMART2");
        stringMap.put(EDGE1000_THAI, "EDGE1000_THAI");
        stringMap.put(VARIA_REMOTE, "VARIA_REMOTE");
        stringMap.put(EDGE25_ASIA, "EDGE25_ASIA");
        stringMap.put(EDGE25_JPN, "EDGE25_JPN");
        stringMap.put(EDGE20_ASIA, "EDGE20_ASIA");
        stringMap.put(APPROACH_X40, "APPROACH_X40");
        stringMap.put(FENIX3_JAPAN, "FENIX3_JAPAN");
        stringMap.put(VIVO_SMART_EMEA, "VIVO_SMART_EMEA");
        stringMap.put(FR630_ASIA, "FR630_ASIA");
        stringMap.put(FR630_JPN, "FR630_JPN");
        stringMap.put(FR230_JPN, "FR230_JPN");
        stringMap.put(HRM4_RUN, "HRM4_RUN");
        stringMap.put(EPIX_JAPAN, "EPIX_JAPAN");
        stringMap.put(VIVO_ACTIVE_HR, "VIVO_ACTIVE_HR");
        stringMap.put(VIVO_SMART_GPS_HR, "VIVO_SMART_GPS_HR");
        stringMap.put(VIVO_SMART_HR, "VIVO_SMART_HR");
        stringMap.put(VIVO_SMART_HR_ASIA, "VIVO_SMART_HR_ASIA");
        stringMap.put(VIVO_SMART_GPS_HR_ASIA, "VIVO_SMART_GPS_HR_ASIA");
        stringMap.put(VIVO_MOVE, "VIVO_MOVE");
        stringMap.put(VARIA_TAILLIGHT, "VARIA_TAILLIGHT");
        stringMap.put(FR235_JAPAN, "FR235_JAPAN");
        stringMap.put(VARIA_VISION, "VARIA_VISION");
        stringMap.put(VIVO_FIT3, "VIVO_FIT3");
        stringMap.put(FENIX3_KOREA, "FENIX3_KOREA");
        stringMap.put(FENIX3_SEA, "FENIX3_SEA");
        stringMap.put(FENIX3_HR, "FENIX3_HR");
        stringMap.put(VIRB_ULTRA_30, "VIRB_ULTRA_30");
        stringMap.put(INDEX_SMART_SCALE, "INDEX_SMART_SCALE");
        stringMap.put(FR235, "FR235");
        stringMap.put(FENIX3_CHRONOS, "FENIX3_CHRONOS");
        stringMap.put(OREGON7XX, "OREGON7XX");
        stringMap.put(RINO7XX, "RINO7XX");
        stringMap.put(EPIX_KOREA, "EPIX_KOREA");
        stringMap.put(FENIX3_HR_CHN, "FENIX3_HR_CHN");
        stringMap.put(FENIX3_HR_TWN, "FENIX3_HR_TWN");
        stringMap.put(FENIX3_HR_JPN, "FENIX3_HR_JPN");
        stringMap.put(FENIX3_HR_SEA, "FENIX3_HR_SEA");
        stringMap.put(FENIX3_HR_KOR, "FENIX3_HR_KOR");
        stringMap.put(NAUTIX, "NAUTIX");
        stringMap.put(VIVO_ACTIVE_HR_APAC, "VIVO_ACTIVE_HR_APAC");
        stringMap.put(OREGON7XX_WW, "OREGON7XX_WW");
        stringMap.put(EDGE_820, "EDGE_820");
        stringMap.put(EDGE_EXPLORE_820, "EDGE_EXPLORE_820");
        stringMap.put(FR735XT_APAC, "FR735XT_APAC");
        stringMap.put(FR735XT_JAPAN, "FR735XT_JAPAN");
        stringMap.put(FENIX5S, "FENIX5S");
        stringMap.put(D2_BRAVO_TITANIUM, "D2_BRAVO_TITANIUM");
        stringMap.put(VARIA_UT800, "VARIA_UT800");
        stringMap.put(RUNNING_DYNAMICS_POD, "RUNNING_DYNAMICS_POD");
        stringMap.put(EDGE_820_CHINA, "EDGE_820_CHINA");
        stringMap.put(EDGE_820_JAPAN, "EDGE_820_JAPAN");
        stringMap.put(FENIX5X, "FENIX5X");
        stringMap.put(VIVO_FIT_JR, "VIVO_FIT_JR");
        stringMap.put(VIVO_SMART3, "VIVO_SMART3");
        stringMap.put(VIVO_SPORT, "VIVO_SPORT");
        stringMap.put(EDGE_820_TAIWAN, "EDGE_820_TAIWAN");
        stringMap.put(EDGE_820_KOREA, "EDGE_820_KOREA");
        stringMap.put(EDGE_820_SEA, "EDGE_820_SEA");
        stringMap.put(FR35_HEBREW, "FR35_HEBREW");
        stringMap.put(APPROACH_S60, "APPROACH_S60");
        stringMap.put(FR35_APAC, "FR35_APAC");
        stringMap.put(FR35_JAPAN, "FR35_JAPAN");
        stringMap.put(FENIX3_CHRONOS_ASIA, "FENIX3_CHRONOS_ASIA");
        stringMap.put(VIRB_360, "VIRB_360");
        stringMap.put(FR935, "FR935");
        stringMap.put(FENIX5, "FENIX5");
        stringMap.put(VIVOACTIVE3, "VIVOACTIVE3");
        stringMap.put(FR235_CHINA_NFC, "FR235_CHINA_NFC");
        stringMap.put(FORETREX_601_701, "FORETREX_601_701");
        stringMap.put(VIVO_MOVE_HR, "VIVO_MOVE_HR");
        stringMap.put(EDGE_1030, "EDGE_1030");
        stringMap.put(FENIX5_ASIA, "FENIX5_ASIA");
        stringMap.put(FENIX5S_ASIA, "FENIX5S_ASIA");
        stringMap.put(FENIX5X_ASIA, "FENIX5X_ASIA");
        stringMap.put(APPROACH_Z80, "APPROACH_Z80");
        stringMap.put(FR35_KOREA, "FR35_KOREA");
        stringMap.put(D2CHARLIE, "D2CHARLIE");
        stringMap.put(VIVO_SMART3_APAC, "VIVO_SMART3_APAC");
        stringMap.put(VIVO_SPORT_APAC, "VIVO_SPORT_APAC");
        stringMap.put(FR935_ASIA, "FR935_ASIA");
        stringMap.put(DESCENT, "DESCENT");
        stringMap.put(FR645, "FR645");
        stringMap.put(FR645M, "FR645M");
        stringMap.put(FR30, "FR30");
        stringMap.put(FENIX5S_PLUS, "FENIX5S_PLUS");
        stringMap.put(EDGE_130, "EDGE_130");
        stringMap.put(EDGE_1030_ASIA, "EDGE_1030_ASIA");
        stringMap.put(VIVOSMART_4, "VIVOSMART_4");
        stringMap.put(VIVO_MOVE_HR_ASIA, "VIVO_MOVE_HR_ASIA");
        stringMap.put(APPROACH_X10, "APPROACH_X10");
        stringMap.put(FR30_ASIA, "FR30_ASIA");
        stringMap.put(VIVOACTIVE3M_W, "VIVOACTIVE3M_W");
        stringMap.put(FR645_ASIA, "FR645_ASIA");
        stringMap.put(FR645M_ASIA, "FR645M_ASIA");
        stringMap.put(EDGE_EXPLORE, "EDGE_EXPLORE");
        stringMap.put(GPSMAP66, "GPSMAP66");
        stringMap.put(APPROACH_S10, "APPROACH_S10");
        stringMap.put(VIVOACTIVE3M_L, "VIVOACTIVE3M_L");
        stringMap.put(APPROACH_G80, "APPROACH_G80");
        stringMap.put(EDGE_130_ASIA, "EDGE_130_ASIA");
        stringMap.put(EDGE_1030_BONTRAGER, "EDGE_1030_BONTRAGER");
        stringMap.put(FENIX5_PLUS, "FENIX5_PLUS");
        stringMap.put(FENIX5X_PLUS, "FENIX5X_PLUS");
        stringMap.put(EDGE_520_PLUS, "EDGE_520_PLUS");
        stringMap.put(EDGE_530, "EDGE_530");
        stringMap.put(EDGE_830, "EDGE_830");
        stringMap.put(FENIX5S_PLUS_APAC, "FENIX5S_PLUS_APAC");
        stringMap.put(FENIX5X_PLUS_APAC, "FENIX5X_PLUS_APAC");
        stringMap.put(EDGE_520_PLUS_APAC, "EDGE_520_PLUS_APAC");
        stringMap.put(FR235L_ASIA, "FR235L_ASIA");
        stringMap.put(FR245_ASIA, "FR245_ASIA");
        stringMap.put(VIVO_ACTIVE3M_APAC, "VIVO_ACTIVE3M_APAC");
        stringMap.put(VIVO_SMART4_ASIA, "VIVO_SMART4_ASIA");
        stringMap.put(VIVOACTIVE4_SMALL, "VIVOACTIVE4_SMALL");
        stringMap.put(VIVOACTIVE4_LARGE, "VIVOACTIVE4_LARGE");
        stringMap.put(VENU, "VENU");
        stringMap.put(MARQ_DRIVER, "MARQ_DRIVER");
        stringMap.put(MARQ_AVIATOR, "MARQ_AVIATOR");
        stringMap.put(MARQ_CAPTAIN, "MARQ_CAPTAIN");
        stringMap.put(MARQ_COMMANDER, "MARQ_COMMANDER");
        stringMap.put(MARQ_EXPEDITION, "MARQ_EXPEDITION");
        stringMap.put(MARQ_ATHLETE, "MARQ_ATHLETE");
        stringMap.put(FENIX6S_SPORT, "FENIX6S_SPORT");
        stringMap.put(FENIX6S, "FENIX6S");
        stringMap.put(FENIX6_SPORT, "FENIX6_SPORT");
        stringMap.put(FENIX6, "FENIX6");
        stringMap.put(FENIX6X, "FENIX6X");
        stringMap.put(HRM_DUAL, "HRM_DUAL");
        stringMap.put(VIVO_MOVE3_PREMIUM, "VIVO_MOVE3_PREMIUM");
        stringMap.put(APPROACH_S40, "APPROACH_S40");
        stringMap.put(FR245M_ASIA, "FR245M_ASIA");
        stringMap.put(EDGE_530_APAC, "EDGE_530_APAC");
        stringMap.put(EDGE_830_APAC, "EDGE_830_APAC");
        stringMap.put(VIVO_MOVE3, "VIVO_MOVE3");
        stringMap.put(VIVO_ACTIVE4_SMALL_ASIA, "VIVO_ACTIVE4_SMALL_ASIA");
        stringMap.put(VIVO_ACTIVE4_LARGE_ASIA, "VIVO_ACTIVE4_LARGE_ASIA");
        stringMap.put(VIVO_ACTIVE4_OLED_ASIA, "VIVO_ACTIVE4_OLED_ASIA");
        stringMap.put(SWIM2, "SWIM2");
        stringMap.put(MARQ_DRIVER_ASIA, "MARQ_DRIVER_ASIA");
        stringMap.put(MARQ_AVIATOR_ASIA, "MARQ_AVIATOR_ASIA");
        stringMap.put(VIVO_MOVE3_ASIA, "VIVO_MOVE3_ASIA");
        stringMap.put(VIVO_ACTIVE3T_CHN, "VIVO_ACTIVE3T_CHN");
        stringMap.put(MARQ_CAPTAIN_ASIA, "MARQ_CAPTAIN_ASIA");
        stringMap.put(MARQ_COMMANDER_ASIA, "MARQ_COMMANDER_ASIA");
        stringMap.put(MARQ_EXPEDITION_ASIA, "MARQ_EXPEDITION_ASIA");
        stringMap.put(MARQ_ATHLETE_ASIA, "MARQ_ATHLETE_ASIA");
        stringMap.put(FR45_ASIA, "FR45_ASIA");
        stringMap.put(VIVOACTIVE3_DAIMLER, "VIVOACTIVE3_DAIMLER");
        stringMap.put(FENIX6S_SPORT_ASIA, "FENIX6S_SPORT_ASIA");
        stringMap.put(FENIX6S_ASIA, "FENIX6S_ASIA");
        stringMap.put(FENIX6_SPORT_ASIA, "FENIX6_SPORT_ASIA");
        stringMap.put(FENIX6_ASIA, "FENIX6_ASIA");
        stringMap.put(FENIX6X_ASIA, "FENIX6X_ASIA");
        stringMap.put(MARQ_ADVENTURER, "MARQ_ADVENTURER");
        stringMap.put(MARQ_ADVENTURER_ASIA, "MARQ_ADVENTURER_ASIA");
        stringMap.put(SWIM2_APAC, "SWIM2_APAC");
        stringMap.put(VENU_DAIMLER_ASIA, "VENU_DAIMLER_ASIA");
        stringMap.put(VENU_DAIMLER, "VENU_DAIMLER");
        stringMap.put(SDM4, "SDM4");
        stringMap.put(EDGE_REMOTE, "EDGE_REMOTE");
        stringMap.put(TRAINING_CENTER, "TRAINING_CENTER");
        stringMap.put(CONNECTIQ_SIMULATOR, "CONNECTIQ_SIMULATOR");
        stringMap.put(ANDROID_ANTPLUS_PLUGIN, "ANDROID_ANTPLUS_PLUGIN");
        stringMap.put(CONNECT, "CONNECT");
    }


    /**
     * Retrieves the String Representation of the Value
     * @return The string representation of the value, or empty if unknown
     */
    public static String getStringFromValue( Integer value ) {
        if( stringMap.containsKey( value ) ) {
            return stringMap.get( value );
        }

        return "";
    }

    /**
     * Retrieves a value given a string representation
     * @return The value or INVALID if unkwown
     */
    public static Integer getValueFromString( String value ) {
        for( Map.Entry<Integer, String> entry : stringMap.entrySet() ) {
            if( entry.getValue().equals( value ) ) {
                return entry.getKey();
            }
        }

        return INVALID;
    }

}
